//Copyright 2013 Radiologics, Inc
//Author: Tim Olsen <tim@radiologics.com>

/* 
 * resource dialog is used to upload resources as an experiment level resource
 */
XNAT.app.projRes={
	resource_label:"",
	project:"",
	loaded:false,
	ready:false,
	show:function(){
		//if its initialized, then show it, otherwise initialize it.
		if(!this.loaded){
			this.loaded=true;
			this.start();
		}else if(this.ready){
			XNAT.app.projRes.dialog.render(document.body);
			XNAT.app.projRes.dialog.show();
		}
	},
	disableLink:function(){
		//mark link as disabled so that it is obvious that this won't work
		YUIDOM.get('upl_adl_files_a').style.color='grey';
		YUIDOM.get('upl_adl_files_a').style.cursor='text';
	},
	start:function(){		  		
		//triggers the initial load of the resource list for the select box
		openModalPanel("resource_loading","Loading");
		YAHOO.util.Connect.asyncRequest('GET', serverRoot+'/data/projects/' + this.project + '/config/project_resources/script?format=json', {success : this.handleResLoad, failure : function(){
			closeModalPanel("resource_loading");
			XNAT.app.projRes.disableLink();
		}, cache : false, scope : this});
	},
	handleResLoad:function(obj){
		//handles the response with the available resources for this project
		closeModalPanel("resource_loading");
		var parsedResponse = YAHOO.lang.JSON.parse(obj.responseText);
	    var script = "";
	    if (parsedResponse.ResultSet.Result.length !== 0) {
			script = parsedResponse.ResultSet.Result[0].script;
			//sort of a hack to get this code to work with generic nrg_config return values
			if(script == undefined ){
				script = parsedResponse.ResultSet.Result[0].contents;
			}
			
			//parse json from config service
			var resources=YAHOO.lang.JSON.parse(script);
			if(resources.length>0){
				this.ready=true;
			}else{
				this.disableLink();
				return;
			}

			//render select options
			$.each(resources,function(index,value){
				$('#ruSel').append($("<option value='" + value.label +"' data-message='" + value.message +"'>" + value.label +"</option>"));
			});
		
			//add onchange event
			$('#ruSel').change(function(){
				XNAT.app.projRes.resource_label=$("#ruSel option:selected").attr("value")
				if(XNAT.app.projRes.resource_label!=""){
					var desc=$("#ruSel option:selected").attr("data-message");
					if(desc!=null && desc!=undefined){
						$('#ruMsg').html('<b>Instructions for uploading to <b>' + XNAT.app.projRes.resource_label + '</b>:</b>&nbsp;' + desc);
					}
				}
			});
			
			this.show();
		}
	},
	doUpload:function(){
		//executes the selected upload operation
		var frm=document.getElementById("res_upload_frm");
		if(XNAT.app.projRes.resource_label==""){
			showMessage("page_body","Select resource","Please select a resource to upload.");
			return;
		}
		if(frm.event_reason.value==""){
			showMessage("page_body","Include justification.","Please include a justification for this upload.");
			return;
		}
		if(frm.upload_file.value==""){
			showMessage("page_body","Select file.","Please use the file selector to choose a file to upload.");
			return;
		}		
		YAHOO.util.Connect.setForm(frm,true);
		
		var callback={
			upload:function(obj1){		
				closeModalPanel("res_upl_mdl");
				this.handleUpload(obj1);
			},
			scope:this
		}

		var params="";		
		params+="event_type=WEB_FORM";
		params+="&event_action=Uploaded "+ this.resource_label;
		params+="&extract=true";
		params+="&event_reason="+frm.event_reason.value;
		
		openModalPanel("res_upl_mdl","Uploading Files");
		
		YAHOO.util.Connect.asyncRequest('POST',serverRoot+"/REST/projects/"+ this.project +"/resources/"+ this.resource_label +"/files?XNAT_CSRF=" + csrfToken + "&"+params,callback);
	},
	handleUpload:function(response){
		//handles the response form the upload operation
		//because this is a file upload, both successes and failures will use this method
		if(response.responseText=="" || response.responseText=="<pre></pre>"){
			showMessage("page_body","Upload successful.","Your files have been successfully uploaded.");
			window.location.reload(true);
		}else if(response.responseText!=undefined && response.responseText.indexOf("File already exists")>-1){
			showMessage("page_body","Failed upload.","The selected files already exist for this project.");
		}else if(response.responseText==undefined){
			//this block is for IE.  For some reason the responseText is coming through as undefined.
			showMessage("page_body","Failed upload.","Unable to upload selected files.");
		}else{
			showMessage("page_body","Failed upload.",response.responseText);
		}
		
		this.dialog.hide();
	}
}


//initialize modal upload dialog
XNAT.app.projRes.dialog=new YAHOO.widget.Dialog("res_dialog", { fixedcenter:true, visible:false, width:"500px", height:"300px", modal:true, close:true, draggable:true } ),
XNAT.app.projRes.dialog.cfg.queueProperty("buttons", [{ text:"Cancel", handler:{fn:function(){XNAT.app.projRes.dialog.hide();}}},{ text:"Upload", handler:{fn:function(){XNAT.app.projRes.doUpload();}}, isDefault:true}]);
